//+------------------------------------------------------------------+
//|                                                  RSI on NMA.mq4  |
//|                                         by brax64 for forex-tsd  |
//+------------------------------------------------------------------+
#property copyright "brax64"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DodgerBlue  
#property indicator_width1  2

extern int RsiPeriod     = 14;
extern int RsiPrice      = PRICE_CLOSE;
extern int NMA_Length    = 7;
extern int NMA_S_Length  = 3;
extern int NMA_Mode      = MODE_LWMA;
extern int Smooth_Length = 3;
extern int Smooth_Mode   = MODE_SMMA;

double rsi[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,rsi);
      if(Smooth_Length < 1) Smooth_Length = 1;
   IndicatorShortName("RSI on NMA ("+RsiPeriod+","+NMA_Length+","+Smooth_Length+")");
   return(0);
}
int deinit() { return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   for(int i=limit; i>=0; i--) rsi[i] = iCustomMa(iRsi(iNma(iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i),NMA_Length,NMA_S_Length,NMA_Mode,i),RsiPeriod,i),Smooth_Length,Smooth_Mode,i,2);
   return(0);
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workRsi[][1];
#define _price  0

double iRsi(double price, double period, int i, int instanceNo=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo; 
      int r = Bars-i-1;
   
      workRsi[r][z+_price] = price;

      
         double sump = 0;
         double sumn = 0;
         for (int k=0; k<period; k++)
         {
            double diff = workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price];
               if (diff > 0) sump += diff;
               if (diff < 0) sumn -= diff;
         }
         if (sumn > 0)
               return(100.0-100.0/(1.0+sump/sumn));
         else  return(50);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double iNma(double price, double period, double samplePeriod, int mode, int i, int instanceNo=0)
{
   double Lambda = period / samplePeriod;
       if(Lambda < 2.0)
       {
          Lambda = 2.0; samplePeriod = period / 2.0;
       }
   double Alpha  = Lambda * (period - 1.0) / (period - Lambda);

   //
   //
   //
   //
   //

   double sample = iCustomMa(price ,period      ,mode,i,0);
   double gamma  = iCustomMa(sample,samplePeriod,mode,i,1);
      return((Alpha+1.0)*sample - Alpha*gamma);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _maWorkBufferx1 3
#define _maWorkBufferx2 6
#define _maWorkBufferx3 9
double iCustomMa(double price, double length, int mode, int i, int instanceNo=0)
{
   int r = Bars-i-1;
   switch (mode)
   {
      case 0  : return(iSma(price,length,r,instanceNo));
      case 1  : return(iEma(price,length,r,instanceNo));
      case 2  : return(iSmma(price,length,r,instanceNo));
      case 3  : return(iLwma(price,length,r,instanceNo));
      default : return(0);
   }
}

//
//
//
//
//

double workSma[][_maWorkBufferx2];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}

//
//
//
//
//

double workEma[][_maWorkBufferx1];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars);

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//
//
//
//
//

double workSmma[][_maWorkBufferx1];
double iSmma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= Bars) ArrayResize(workSmma,Bars);

   //
   //
   //
   //
   //

   if (r<period)
         workSmma[r][instanceNo] = price;
   else  workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//
//
//
//
//

double workLwma[][_maWorkBufferx1];
double iLwma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workLwma,0)!= Bars) ArrayResize(workLwma,Bars);
   
   //
   //
   //
   //
   //
   
   workLwma[r][instanceNo] = price;
      double sumw = period;
      double sum  = period*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*workLwma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}